/*
 * Sixth 3D engine. Copyright ©2012-2018, Svjatoslav Agejenko, svjatoslav@svjatoslav.eu
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of version 3 of the GNU Lesser General Public License
 * or later as published by the Free Software Foundation.
 *
 */

package eu.svjatoslav.sixth.e3d.renderer.raster.slicer;

import eu.svjatoslav.sixth.e3d.geometry.Point2D;
import eu.svjatoslav.sixth.e3d.geometry.Point3D;

import java.util.Comparator;

public class BorderLine implements Comparator<BorderLine> {

    public final int count;
    final PolygonCoordinate c1;
    final PolygonCoordinate c2;

    public BorderLine(final PolygonCoordinate c1, final PolygonCoordinate c2,
                      final int count) {
        this.c1 = c1;
        this.c2 = c2;
        this.count = count;
    }

    @Override
    public int compare(final BorderLine o1, final BorderLine o2) {
        return Double.compare(o1.getLength(), o2.getLength());
    }

    public double getLength() {
        return c1.space.getDistanceTo(c2.space);
    }

    public PolygonCoordinate getMiddlePoint() {
        return new PolygonCoordinate(new Point3D().computeMiddlePoint(c1.space,
                c2.space), new Point2D().getMiddle(c1.texture,
                c2.texture));
    }
}
